              #include <p16f630.inc>
              LIST        p=16F630          ;   .
              __CONFIG    0181H ;  0181H            ;   4( 3F81)

Sec           equ         20h
Sec2          equ         21h
Sec1          equ         22h
var           equ         23h
kod           equ         24h
shetbit       equ         25h
Sec3          equ         26h
flag          equ         27h
skor          equ         28h
shet          equ         29h
eepsec        equ         2Ah
t1L           equ         2Bh
t1H           equ         2Ch

W_TEMP        equ         5Eh
STATUS_TEMP   equ         5Fh

#define       right       PORTA,0            ;   -
#define       left        PORTA,3
#define       up          PORTA,1
#define       down        PORTA,2

#define       dat         PORTC,1
#define       led         PORTC,3

              org         0                 ;      0 PC.
              goto        Start             ;    Start.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  

              org         0004h             ;     0004h
       
              movwf       W_TEMP            ;   
              swapf       STATUS,W          ;
              clrf        STATUS            ;
              movwf       STATUS_TEMP       ;
                 
              incfsz      t1L,F
              goto        int_1
              incf        t1H,F

int_1         btfsc       flag,1
              goto        int_2

              movf        t1H,W          ;   262  (2  TMR1)
              sublw       .0             ;
              btfss       STATUS,C          ;
              goto        int_sbros                        ; 
                                            ;
              btfss       STATUS,Z          ;
              goto        int_ex              ; 
              movf        t1L,W             ;
              sublw       .1           ;
              btfsc       STATUS,C 
              goto        int_ex
              goto        int_sbros   

int_2         movf        t1H,W          ;   2  (916  TMR1)
              sublw       .3             ;  3
              btfss       STATUS,C          ;
              goto        int_sbros                        ; 
                                            ;
              btfss       STATUS,Z          ;
              goto        int_ex              ; 
              movf        t1L,W             ;
              sublw       .148           ;148
              btfsc       STATUS,C 
              goto        int_ex  
       
int_sbros     bsf         flag,0
              bcf         T1CON,TMR1ON
              clrf        TMR1L
              clrf        TMR1H
              clrf        t1L
              clrf        t1H
int_ex        bcf         PIR1,TMR1IF       ;   . TMR1
              

              swapf       STATUS_TEMP,W     ;   
              movwf       STATUS            ;
              swapf       W_TEMP,F          ;
              swapf       W_TEMP,W          ;
                                            ;
              retfie                        ;    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      
Start         movlw       b'00000111'       ; 
              movwf       CMCON             ;
              clrf        PORTA             ;      PORTA
              clrf        PORTC             ;
              bsf         STATUS,RP0        ; 1- 
              movlw       b'11110101'       ;  \  PORTC
              movwf       TRISC             ;
              movlw       b'11111111'       ;  \  PORTA
              movwf       TRISA

              movlw       b'00001111'       ;    
              movwf       IOCA              ;
           
              bcf         STATUS,RP0        ; 0- 

            
              bsf         STATUS,RP0
              movlw       0x00
              movwf       EEADR
              bsf         EECON1,RD
              movf        EEDATA,W
              bcf         STATUS,RP0
              movwf       skor
              
              movlw       .1
              subwf       skor,W
              btfss       STATUS,C
              goto        standrt
              movf        skor,W
              sublw       .108             ;54
              btfsc       STATUS,C 
              goto        met_dal 
standrt       movlw       .31
              movwf       skor

met_dal       movlw       b'00010000'       ; ,  1:2
              movwf       T1CON
              
              clrf        TMR1L
              clrf        TMR1H
              clrf        t1L
              clrf        t1H
              clrf        flag

              bcf         PIR1,TMR1IF       ;   . TMR1
              bsf         STATUS,RP0        ; 1- 
              bsf         PIE1,TMR1IE       ;   .TMR1
              bcf         STATUS,RP0        ; 0- 
              bsf         INTCON,PEIE       ;  . 

             
              movf        PORTA,W           ;    
              bcf         INTCON,RAIF       ;     
              bsf         INTCON,RAIE       ;    
              

son           SLEEP
              bcf         INTCON,RAIE       ;    
              bsf         INTCON,GIE        ;  
              bsf         T1CON,TMR1ON      ; TMR1


opros         btfsc       up            ;
              goto        op_p1        ;
              movlw       .3            ;
              movwf       shet
op1           call        paus_pr         ;
              btfsc       up            ;
              goto        prog_op1           ;
              btfss       down
              goto        kan_1
              decfsz      shet,F          ;
              goto        op1             ;
op11          call        upp        ;
              
              btfsc       up           ;
              goto        op_p1        ;
              goto        op11            ; 
                                          ;
 
prog_op1      call        upp        ;
 
op_p1         btfsc       down            ;
              goto        op_p2        ;
              movlw       .3            ;
              movwf       shet
op2           call        paus_pr         ;
              btfsc       down            ;
              goto        prog_op2           ;
              btfss       right
              goto        pr_skor
              btfss       up
              goto        kan_1
              decfsz      shet,F          ;
              goto        op2             
op22          call        dwn        ;
             
              btfsc       down           ;
              goto        op_p2        ;
              goto        op22            ;
                                          ;
 
prog_op2      call        dwn        ;


op_p2         btfsc       right            ;
              goto        op_p3        ;
              movlw       .3            ;
              movwf       shet
op3           call        paus_pr         ;
              btfsc       right            ;
              goto        prog_op3           ;
              btfss       down
              goto        pr_skor
              btfss       left
              goto        kan_2
              decfsz      shet,F          ;
              goto        op3             ;
op33          call        rght        ;
              
              btfsc       right           ;
              goto        op_p3        ;
              goto        op33            ; 
                                          ;
 
prog_op3      call        rght        ;
 
op_p3         btfsc       left            ;
              goto        op_p4        ;
              movlw       .3            ;
              movwf       shet
op4           call        paus_pr         ;
              btfsc       left            ;
              goto        prog_op4           ;
              btfss       right
              goto        kan_2
              decfsz      shet,F          ;
              goto        op4             
op44          call        lft
              btfsc       left           ;
              goto        op_p4        ;
              goto        op44            ;
                                          ;
 
prog_op4      call        lft 




op_p4         btfss       flag,0            ;   TMR1
              goto        opros
              bcf         flag,0
              bcf         INTCON,GIE        ;  
              movf        PORTA,W           ;    
              bcf         INTCON,RAIF       ;     
              bsf         INTCON,RAIE       ;    
              goto        son
              

pr_skor       bsf         led
              bcf         T1CON,TMR1ON
                          
met_pr1       call        paus_pr
              btfss       right
              goto        met_pr1
              btfss       down
              goto        met_pr1
              bsf         flag,1
              call        clr_tmr1


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

knp_pr        btfsc       up            ;
              goto        met_p1        ;
              movlw       .15            ;
              movwf       shet
kn1           call        paus_pr         ;
              btfsc       up            ;
              goto        prog1           ;
              
              decfsz      shet,F          ;
              goto        kn1             ;
kn11          call        uvel_skor        ;
              
              btfsc       up           ;
              goto        met_p1        ;
              goto        kn11            ; 
                                          ;
 
prog1         call        uvel_skor        ;
 
met_p1        btfsc       down            ;
              goto        met_p2        ;
              movlw       .15            ;
              movwf       shet
kn2           call        paus_pr         ;
              btfsc       down            ;
              goto        prog2           ;
              btfss       right
              goto        exit_pr
              decfsz      shet,F          ;
              goto        kn2             
kn22          call        umen_skor        ;
             
              btfsc       down           ;
              goto        met_p2        ;
              goto        kn22            ;
                                          ;
 
prog2         call        umen_skor        ;
                                          ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
           

              
met_p2        btfsc       right            ; 1- 
              goto        met_p3        ;1-   :    2-  
              movlw       .3            ;1-  :   100   shet
              movwf       shet
kn3           call        paus_pr         ;  (5-20)
              btfsc       right            ; 1- 
              goto        prog3           ;1-  :    prog1
              btfss       down
              goto        exit_pr
              decfsz      shet,F          ;1-   :   shet
              goto        kn3             ;    0:    kn1
kn33          call        rght         ;   0:   program1
              
              btfsc       right           ; 1- 
              goto        met_p3        ;1-  :    oproskn2 
               btfss       down
              goto        exit_pr
              goto        kn33            ;1-   :    kn11  
                                          ;   program1
 
prog3         call        rght         ;  program1


met_p3        btfsc       left            ; 1- 
              goto        met_p4        ;1-   :    2-  
              movlw       .3            ;1-  :   100   shet
              movwf       shet
kn4           call        paus_pr         ;  (5-20)
              btfsc       left            ; 1- 
              goto        prog4           ;1-  :    prog1
              
              decfsz      shet,F          ;1-   :   shet
              goto        kn4             ;    0:    kn1
kn44          call        lft         ;   0:   program1
              
              btfsc       left           ; 1- 
              goto        met_p4        ;1-  :    oproskn2 
              goto        kn44            ;1-   :    kn11  
                                          ;   program1
 
prog4         call        lft         ;  program1
            


met_p4        btfss       flag,0            ;   TMR1
              goto        knp_pr
              bcf         flag,0
              goto        exit_pr
              

umen_skor     call        clr_tmr1
              movf        skor,W               ;
              sublw       .107                    ;53
              btfss       STATUS,C
              return
              incf        skor,F
              bcf         led
              call        paus_pr
              bsf         led
              call        paus_pr
              return


uvel_skor     call        clr_tmr1
              movlw       .2               ;
              subwf       skor,W
              btfss       STATUS,C
              return
              decf        skor,F
              bcf         led
              call        paus_pr
              bsf         led
              call        paus_pr
              return


exit_pr      bcf         T1CON,TMR1ON
             bsf         STATUS,RP0
             movlw       .3
             movwf       eepsec
pov_eep      bcf         STATUS,RP0
             movf        skor,W
             bsf         STATUS,RP0
             movwf       EEDATA          
             movlw       0x00
             movwf       EEADR
             bsf         EECON1,WREN
              movlw       0x55
              movwf       EECON2
              movlw       0xAA
              movwf       EECON2
              bsf         EECON1,WR  
eep1          btfsc       EECON1,WR
              goto        eep1
              bcf         EECON1,WREN

             movf        EEDATA,W
             bsf         EECON1,RD
             subwf       EEDATA,W
             btfsc       STATUS,Z
             goto        eep_ok
             decfsz      eepsec,F
             goto        pov_eep
            
             
eep_ok       bcf         STATUS,RP0
met_ee1       call        paus_pr
              btfss       down
              goto        met_ee1
              btfss       right
              goto        met_ee1
              bcf         flag,1
              call        clr_tmr1
              bcf         led
              goto        opros


                                            
rght          call        clr_tmr1          ;;    22
              btfss       flag,1
              bsf         led
              call        preamb            ;   
              movlw       .22              ;  
              call        send  
              movlw       .22              ;  
              call        send 
              btfss       flag,1            ; 
              bcf         led
              call        pausend
              return

lft           call        clr_tmr1         ;    11
              btfss       flag,1
              bsf         led
              call        preamb            ;   
              movlw       .11              ;  
              call        send  
              movlw       .11              ;  
              call        send             ; 
              btfss       flag,1
              bcf         led
              call        pausend
              return
              

upp           call        clr_tmr1          ;    44
              btfss       flag,1
              bsf         led
              call        preamb            ;   
              movlw       .44              ;  
              call        send  
              movlw       .44              ;  
              call        send             ; 
              btfss       flag,1
              bcf         led
              call        pausend
              return

dwn           call        clr_tmr1          ;    33
              btfss       flag,1
              bsf         led
              call        preamb            ;   
              movlw       .33              ;  
              call        send  
              movlw       .33              ;  
              call        send             ; 
              btfss       flag,1
              bcf         led
              call        pausend
              return

kan_1         bcf         T1CON,TMR1ON
              btfss       flag,1
              bsf         led  
              call        preamb            ;   
              movlw       .15              ;  
              call        send  
              movlw       .15              ;  
              call        send             ; 
              
              btfss       flag,1
              bcf         led
met1          call        pausend
              btfss       up
              goto        met1
              btfss       down
              goto        met1
              call        clr_tmr1
              goto        opros

kan_2         bcf         T1CON,TMR1ON
              btfss       flag,1
              bsf         led
              call        preamb            ;   
              movlw       .25              ;  
              call        send  
              movlw       .25              ;  
              call        send             ; 
              bcf         T1CON,TMR1ON
              btfss       flag,1
              bcf         led
met2          call        pausend
              btfss       right
              goto        met2
              btfss       left
              goto        met2
              call        clr_tmr1
              goto        opros
              
              
             
clr_tmr1      bcf         T1CON,TMR1ON      ;  TMR1,    
              clrf        TMR1L
              clrf        TMR1H
              clrf        t1H
              clrf        t1L
              bsf         T1CON,TMR1ON
              return


send          movwf       kod
              movlw       .8                ;  8   shetbit,   
              movwf       shetbit           ;  
ss1           btfsc       kod,7             ; 7-   kod
              goto        prdedin           ;  1:   prdedin 

prdnol        bcf         dat               ;  0:  
              call        paus200
              bsf         dat
              call        paus100
              goto        metka1
                          
prdedin       bcf         dat               ;  
              call        paus100
              bsf         dat
              call        paus200

metka1        rlf         kod,F             ;   kod   
                                            ; 
              decfsz      shetbit,F         ;   
              goto        ss1               ;   :   opros
              bcf         dat               ;  :   dat(   
                                            ;    )
              return                        ;  







preamb        movlw       .8                ;    -
              movwf       var               ;-      
bb1           bcf         dat               ;(010101...01) 16  - 2 
              call        paus100
              bsf         dat
              call        paus100
              decfsz      var,F
              goto        bb1
              return



pausend       movf        skor,W             ; (0,5)x1...54 = 0,5-27,5                 
              movwf       Sec1
p3            movlw       .166
              movwf       Sec             ;
p2            decfsz      Sec,F           ;
              goto        p2              ;
              decfsz      Sec1,F          ;
              goto        p3              ;
              return                      ;
                                          ;

;pausend       movlw       .15               ;  2
;              movwf       Sec
;ar2           movlw       .45
;              movwf       Sec2
;ar1           decfsz      Sec2,F
;              goto        ar1
;              decfsz      Sec,F
;              goto        ar2
;              return

paus_pr       movlw       .65            ; 50 
              movwf       Sec1
pp2           movlw       .255
              movwf       Sec             ;
pp1           decfsz      Sec,F           ;
              goto        pp1              ;
              decfsz      Sec1,F          ;
              goto        pp2  
              return                      



paus100       movlw       .30               ;  100
              movwf       Sec2
aa1           decfsz      Sec2,F
              goto        aa1
              return 

paus200       movlw       .64              ;  200
              movwf       Sec2
aa2           decfsz      Sec2,F
              goto        aa2
              return 

paus_sec      movlw       .5                ;  1
              movwf       Sec
as2           movlw       .255
              movwf       Sec2
as3           movlw       .255
              movwf       Sec1
as1           decfsz      Sec1,F
              goto        as1
              decfsz      Sec2,F
              goto        as3
              decfsz      Sec,F
              goto        as2
              return

              End                            ;  

